	<?php

	// iPay88 backend file
	// 2018 iPay88 Indonesia
	// author aldamustafri@ipay88.co.id

	require_once('../../../wp-config.php');
	global $wpdb;		
	$gateway 				= new Charitable_Gateway_ipay88();
	$prefix  				= $wpdb->prefix;
	
	function update_donation_log($donation, $message)
	{
		if (version_compare(charitable()->get_version(), '1.4.0', '<')) 
		{
			return Charitable_Donation::update_donation_log($donation->ID, $message);
		}
		
		return $donation->update_donation_log($message);
	}

	//redirect create payment
	if (isset($_REQUEST['ipay88_action'])) 
	{
		$plugins_url 	= plugins_url();	
		$assets_image_url = $plugins_url.'/ipay88-wpcharitable-v1.6/includes/gateway/assets/images/';

		$req = json_decode(stripslashes($_REQUEST['ipay88_request']), true);

		$all_payment_type = array_merge($gateway->get_value('payment_type_creditcard'), $gateway->get_value('payment_type_ewallet'), $gateway->get_value('payment_type_atm'), $gateway->get_value('payment_type_onlinebanking'), $gateway->get_value('payment_type_others'));
		
		$donation_id		= explode("-", $req['RefNo'])[2];
		$donation    		= charitable_get_donation( $donation_id );
		$payment_method = "";
		$chosen_pay_id = preg_grep('/'."_".$req['PaymentId']."_".'/', $all_payment_type);
		if(count($chosen_pay_id) > 0)
		{
			$payment_method = reset($chosen_pay_id);
		}

		//update payment method gateway name
		if($payment_method != "")
		{
			$wpdb->update($prefix.'postmeta', array('meta_value'=>'iPay88 - '.explode("_", $payment_method)[3]), array('post_id'=>$donation_id, 'meta_key'=>'donation_gateway'));

			$message_admin = "iPay88 Payment Created With Payment Method: ". explode("_", $payment_method)[3];
			update_donation_log($donation, $message_admin);	
			
		}	

		$key = array_keys($req);
		
		echo "<center><h2>Please wait while redirecting...</h2></center>";	
		echo "<center><img src='".$assets_image_url."/ipay88-loader.gif'></center>";	
		echo "<form  name='ipay88_request_paramaters' action='".$_REQUEST['ipay88_action']."' method='POST'>";
		for($i=0;$i<count($req);$i++) 
		{
			echo "<input type='hidden' name='".$key[$i]."' value='".$req[$key[$i]]."' />";
		}
		echo "</form>";
	
		echo '
		<script>
			(function() {
				document.ipay88_request_paramaters.submit();
			})();
		</script>';
	}
	
	//backendpost
	else if (isset($_REQUEST['TransId']) && isset($_REQUEST['Signature'])) 
	{
		$status_pending			= "charitable-pending";
		$status_completed		= "charitable-completed";
		$status_failed			= "charitable-failed";
		
		//Get signature response
		$signature_response		= $_REQUEST['Signature'];
					
		//Generate signature	
		$MechantKey_response 	= $gateway->get_value('merchant_key');			
		$MerchantCode_response 	= $gateway->get_value('merchant_code');
		$PaymentId_response		= $_REQUEST['PaymentId'];
		$RefNo_response 		= trim(stripslashes($_REQUEST['RefNo']));
		$HashAmount_response 	= str_replace(array(',','.'), "", $_REQUEST['Amount']);
		$Currency_response 		= $_REQUEST['Currency'];
		$Status_response 		= $_REQUEST['Status'];
		$error_response         = $_REQUEST['ErrDesc'];
		$transid_response		= $_REQUEST['TransId'];	


		$merchant_signature		= "";
			
		$merchant_encrypt		= sha1($MechantKey_response.$MerchantCode_response.$PaymentId_response.$RefNo_response.$HashAmount_response.$Currency_response.$Status_response);		
			
		for ($i=0; $i<strlen($merchant_encrypt); $i=$i+2)
		{	
			$merchant_signature .= chr(hexdec(substr($merchant_encrypt,$i,2)));
		}
			
		$merchant_signature_check = base64_encode($merchant_signature);
		

		$donation_id		= explode("-", $RefNo_response)[2];
		$donation    		= charitable_get_donation( $donation_id );
		$get_status 		= $donation->get_status();
		$donor 				= $donation->get_donor();
		$donor_first_name 	= $donor->get_donor_meta('first_name');
		$donor_last_name 	= $donor->get_donor_meta('last_name');
		$donor_username		= $donor_first_name.' '.$donor_last_name;
		$donor_useremail 	= $donor->get_donor_meta('email');
		
		$donation_product 	= html_entity_decode($donation->get_campaigns_donated_to(), ENT_COMPAT, 'UTF-8' );	
		$donation_total		= $donation->get_total_donation_amount(true);
	
		$admin_email 		= get_option('admin_email');		
		$site_info			= get_bloginfo();

		
		$all_payment_type = array_merge($gateway->get_value('payment_type_creditcard'), $gateway->get_value('payment_type_ewallet'), $gateway->get_value('payment_type_atm'), $gateway->get_value('payment_type_onlinebanking'), $gateway->get_value('payment_type_others'));
		
		$payment_method = "";
		$chosen_pay_id = preg_grep('/'."_".$PaymentId_response."_".'/', $all_payment_type);
		if(count($chosen_pay_id) > 0)
		{
			$payment_method = reset($chosen_pay_id);
		}

		//update payment method gateway name
		if($payment_method != "")
		{
			$wpdb->update($prefix.'postmeta', array('meta_value'=>'iPay88 - '.explode("_", $payment_method)[3]), array('post_id'=>$donation_id, 'meta_key'=>'donation_gateway'));
		}	

		//Payment success and signature match
		if ($_REQUEST['Status']=="1" && $merchant_signature_check==$signature_response) 
		{
			if($get_status != $status_completed)
			{
				$message_admin = "iPay88 Payment Completed. Transaction ID: ".$transid_response.".";
			
				if($payment_method != "")
				{
					$message_admin .= " Payment Method: ". explode("_", $payment_method)[3];
				}
	
				update_donation_log($donation, $message_admin);
				
				add_filter('wp_mail_content_type',create_function('', 'return "text/html"; '));
				
				$subject = "Thank you for your donation";
				$headers = 'From: '. $admin_email . "\r\n" .
						   'Reply-To: ' . $admin_email . "\r\n";
				
				$body = '
				<html>	
				<body>
			
					<div id="email_container" style="background:#FFFFFF">          
					<div style="width:570px; padding:0 0 0 20px; margin:50px auto 12px auto" id="email_header">
						<span style="background:#C9C9C9; color:#fff; padding:12px;font-family:trebuchet ms; 
						letter-spacing:1px; -moz-border-radius-topleft:5px; -webkit-border-top-left-radius:5px; 
						border-top-left-radius:5px;moz-border-radius-topright:5px; 
						-webkit-border-top-right-radius:5px; border-top-right-radius:5px;">'.$site_info.'</span>
					</div>
					</div>
			
					<div style="width:550px; padding:0 20px 20px 20px; background:#fff; margin:0 auto; 
					border:1px #BBBBBB solid; moz-border-radius:5px; -webkit-border-radius:5px; border-radius:5px; color:#454545;line-height:1.5em; " id="email_content">						
				
					<h1 style="padding:5px 0 0 0; font-family:georgia;font-weight:500; font-size:24px;color:#000;">
					Your Donation Receipt</h1>
				
						<p>Dear '.$donor_username.',</p>
						<p>Thank you so much for your generous donation.</p>
						
						<p>
						<b>Your Donation Details</b><br>
						'.$donation_product.': IDR '.$donation_total.'
						</p>
					
						<p>With thanks, '.$site_info.'</p>
						
						<div style="text-align:center; border-top:1px solid #eee;
						padding:5px 0 0 0;" id="email_footer"> 
						<small style="font-size:11px; color:#999; line-height:14px;">
						</small>
						</div>
			
					</div>
				 
				</body>
				</html>';
				
				//Here put your Validation and send mail
				$sent = wp_mail($donor_useremail, $subject, $body, $headers);
				
				if($sent) 
				{
					$message_admin = "Email Donation Receipt sent to donor.";
					update_donation_log($donation, $message_admin);
				}
	
				else  
				{
					$message_admin = "Failed to send Email Donation Receipt to donor.";
					update_donation_log($donation, $message_admin);
				}
			
				$wpdb->update($prefix.'posts', array('post_status'=>$status_completed), array('ID'=>$donation_id));		
			}
			
			print_r("RECEIVEOK");exit;		
		}
		
			
		//Payment failed
		else
		{
			if($_REQUEST['Status'] =="3" || $_REQUEST['Status'] == "6")
			{
				$wpdb->update($prefix.'posts', array('post_status'=>$status_pending), array('ID'=>$donation_id));
				print_r("PENDING");exit;
			}
			else
			{
				$wpdb->update($prefix.'posts', array('post_status'=>$status_failed), array('ID'=>$donation_id));
				print_r("BACKEND FAILED");exit;
			}
			
		}			
	}

	
	else
	{
		wp_redirect(get_option('siteurl'));
		exit;
	}
	
	?>